from typing import TypeVar, List
from tudelft.utilities.immutablelist.AbstractPermutations import AbstractPermutations
from tudelft.utilities.immutablelist.ImmutableList import ImmutableList
from tudelft.utilities.immutablelist.FixedList import FixedList

E = TypeVar('E')
class PermutationsWithReturn (AbstractPermutations[E]):
	'''
	Creates all permutations with return (WR).
	
	@param <E> type of the elements
	'''

	def __init__(self, lst:ImmutableList[E] , n:int):
		'''
		all permutations of a given list, drawing n items from the list
		@param list list to be permuted
		@param n    the number of items to draw from the list. Must be between 0
		            and size of list.
		
		'''
		super().__init__(lst, n);
		self._size:int = lst.size() **self._drawsize

	#Override
	def get(self,index:int) ->ImmutableList[E]:
		'''
		Ok this is easy, we just convert the number to base <drawsize>. We do
		this simply using the modulo operator.
		'''
		element:List[E]  = []
		i:int = index;
		for item in range(self._drawsize):
			element.append(self._drawlist.get(i % self._drawlistsize))
			i = i // self._drawlistsize
		return FixedList(element)

	#Override
	def size(self) -> int:
		return self._size

